// Application Window Component Constructor
function ApplicationWindow() {
	var activityIndicator = Ti.UI.createActivityIndicator({
		bottom : 10,
		width : Ti.UI.SIZE,
		height : Ti.UI.SIZE
	});
	activityIndicator.message = 'Loading...';
	setTimeout(function(e) {
		activityIndicator.show();
	}, 200);
	Ti.App.addEventListener('hideLoading', function(e) {
		activityIndicator.hide();
	});
	Ti.App.addEventListener('showLoading', function(e) {
		activityIndicator.show();
	});
	//declarations to make the map click event universal
	//start
	var from = "";
	var cLat = "", cLon = "";
	var des_lat = "";
	var des_lon = "";
	var selectedStore = "";
	var selectedLat = "";
	var selectedLong = "";
	var selectedID = "";
	var selectedTel = "";
	var selectedAdd = "";
	var selectedCity = "";
	var selectedState = "";
	var pinEventAdded = false;
	var mapWin = Ti.UI.createWindow({
		navBarHidden : true,

	});
	var mapWin1 = Ti.UI.createWindow({
		navBarHidden : true
		//	modal:true
	});
	var indexWin = Ti.UI.createWindow({
		navBarHidden : true,
		layout : 'vertical',
		width : '100%',
		height : '100%'

	});
	var lower_in = Titanium.UI.createAnimation({
		bottom : '0dp',
		duration : 500
	});
	var detailsLabelForOpenMap = Ti.UI.createLabel({
		//text : "Click on pins to view details here.",
		color : "white",
		top : '70dp',
		left : '140dp',
		font : {
			fontSize : '8pt',
			fontFamily : 'MyriadPro-BoldCond'
		}
	})
	var callBtn = Ti.UI.createButton({
		top : '170dp',
		//width : '90dp',
		left : '10dp',
		font : {
			fontSize : '6pt',
			fontFamily : 'MyriadPro-BoldCond'

		},
		enabled : false,
		width : '103dp',
		height : '20dp',
		color : 'white',
		backgroundImage : '/HTML/Newfolder/contact.png',
		title : ''
	});
	var getDirectionsBtn = Ti.UI.createButton({
		top : '50dp',
		enabled : false,
		left : '10dp',
		//right : '70dp',
		width : '103dp',
		height : '20dp',
		color : 'blue',
		backgroundImage : '/HTML/Newfolder/get_direction.png'

	});
	var viewReviewsBtn = Ti.UI.createButton({
		top : '90dp',
		enabled : false,
		left : '10dp',
		width : '103dp',
		height : '20dp',
		color : 'blue',
		backgroundImage : '/HTML/Newfolder/view_review.png'
		//title : 'View Reviews'
	});
	var add2favBtn = Ti.UI.createButton({
		top : '130dp',
		enabled : false,
		left : '10dp',
		width : '103dp',
		height : '20dp',
		color : 'blue',
		backgroundImage : '/HTML/Newfolder/add_to_favorites.png'
		//title : 'Add to Favorites'
	});
	var selectedLabel = Ti.UI.createLabel({
		text : "Selected Location",
		color : "yellow",
		top : '50dp',
		left : '140dp',
		font : {
			fontSize : '8pt',
			fontFamily : 'MyriadPro-BoldCond'
		}
	})
	var callText = Ti.UI.createLabel({
		text : "Call ",
		color : "white",
		top : '0dp',
		font : {
			fontSize : '6pt',
			fontFamily : 'MyriadPro-BoldCond'

		}
	})
	var low_viewForOpenMap = Ti.UI.createView({
		backgroundImage : "lowBack.jpg",
		height : "200dp",
		bottom : "-150dp"
	});
	var map = Ti.Map.createView({
		mapType : Titanium.Map.STANDARD_TYPE,
		region : {

			latitudeDelta : 0.5,
			longitudeDelta : 0.5
		},

		animate : true,
		regionFit : true,
		userLocation : true
	});

	var mapEvent = function(e) {
		// from openAll function
		if (from == "openAll") {
			if (e.clicksource == 'pin') {
				var db = Ti.Database.install('speedco.db', 'storeDB');
				var rows = db.execute('SELECT * FROM stores where Store=' + e.annotation.titleid);
				while (rows.isValidRow()) {
					var bizid = rows.fieldByName('Store');
					var sadd = rows.fieldByName('Address');
					var city = rows.fieldByName('City');
					var state = rows.fieldByName('ST');
					var postal = rows.fieldByName('ZIP');
					var telph = rows.fieldByName('Phone');
					var destLat = rows.fieldByName('Latitude');
					var destLong = rows.fieldByName('Longitude');
					var TireService = rows.fieldByName('Tire Store');
					//alert('TireService'+TireService);
					var LubeService = rows.fieldByName('LS');
					//alert('LubeService'+LubeService);
					var AnnualServices = rows.fieldByName('AI');
					var services = [];

					var sLable = "";

					if (TireService == "yes")

						services.push("Tire");

					if (LubeService == "yes")

						services.push("Lube");

					if (AnnualServices == "yes")

						services.push("Inspection");

					if (services.length > 0) {

						if (services.length == 1) {

							sLable = services[0].toString() + " Service";

						} else {

							sLable = services.join(",") + " Services";

						}

					} else

						sLable = "None";
					selectedLat = destLat;
					selectedLong = destLong;
					selectedStore = 'Speedco' + bizid;
					selectedID = bizid;
					selectedTel = telph;
					selectedAdd = sadd;
					selectedCity = city;
					selectedState = state;
					//callBtn.setTitle('CALL NOW');
					if (selectedTel.charAt(0) == 'L' || selectedTel.charAt(0) == 'T') {
						selectedTel = selectedTel.slice(2, 16);
						//alert(selectedTel);
					}
					detailsLabelForOpenMap.setText('Store #' + bizid + '\n' + city + ',' + state + '\n' + sadd + '\n' + selectedTel + '\n\nOffers:' + sLable);
					detailsLabelForOpenMap.setTextAlign(Titanium.UI.TEXT_ALIGNMENT_LEFT);
					callBtn.setTitle('Call ' + selectedTel);
					callText.setText('Call ' + selectedTel);
					callBtn.add(callText);
					getDirectionsBtn.setEnabled(true);
					viewReviewsBtn.setEnabled(true);
					add2favBtn.setEnabled(true);
					callBtn.setEnabled(true);
					//alert(detailsLabel.getText());
					rows.next();
				}
				db.close();
				low_viewForOpenMap.animate(lower_in);
			} else if (e.clicksource == 'leftPane') {

				fireString = 'http://maps.google.com/maps?xyz=xyz&saddr=' + Ti.App.cordlatitude + ',' + Ti.App.cordlongitude + '&daddr=' + selectedLat + ',' + selectedLong;
				Ti.App.fireEvent('TiPlat', {
					url : fireString
				});

			}
		} else if (from == 'f') {
			if (e.clicksource == 'leftPane') {

				fireString = 'http://maps.google.com/maps?xyz=xyz&saddr=' + cLat + ',' + cLon + '&daddr=' + des_lat + ',' + des_lon;
				Ti.App.fireEvent('TiPlat', {
					url : fireString
				});

			}

		}
	}
	map.addEventListener('click', mapEvent);
	//end

	var openMap_event_added = false;
	var event_added = false;

	//activityIndicator.width = 210;
	var route = {};

	htmlInstructions = "";
	var Mileage = "";
	var popaRemoved = false;
	// If you don't want margins around the Translucent or Web View you can set the gutter to zero.
	//var gutter = Ti.Platform.displayCaps.platformWidth * 0.025;
	var gutter = 0;
	var injected = false;
	// The translucent view is a stylish rounded rect behind the web view.
	var translucentViewOn = false;
	// If you want the translucent view or the web view to fade in slowly, set this to true.
	var animationsOn = false;
	// If you don't want a navBar with the corresponding back button you can set this to false.
	// If so, this requires you to have a back button in your HTML on iOS. Android uses standard hardware back button.
	var titleBarOn = false;
	// Set the background color appropriately.
	// var backgroundColor = '#f1e9cf';
	// Popup menu/drawer for forward/back. Without this cross-file links will have no way of getting back to the
	// calling file without a UI in the HTML proper.
	var drawerOn = false;

	var osname = Ti.Platform.osname;

	// Create our main window
	var self = Ti.UI.createWindow({
		backgroundColor : 'transparent',
		// If no image desired, you can remove this line and set the backgroundColor instead.
		// backgroundImage : '/images/background.png',
		//  orientation:Titanium.UI.PORTRAIT,
		//width:200,
		navBarHidden : !titleBarOn, // iOS only
		//       barColor : barColor,
		orientationModes : [Ti.UI.PORTRAIT, Ti.UI.UPSIDE_PORTRAIT],
		modal : true,
		exitOnClose : true // Android only
	});
	var PRWin = Ti.UI.createWindow({
		navBarHidden : true,
		layout : 'vertical',
		width : '100%',
		height : '100%'
	});

	// Create a WebView, this will host the HTML
	var webView = Ti.UI.createWebView({

		showScrollbars : false,

		left : gutter,
		top : gutter,
		right : gutter,
		bottom : gutter,

		opacity : animationsOn ? 0 : 1,
		enableZoomControls : false, // Android only
		// Default assumes that all HTML is in the HTML folder and the first file is index.html, you can change the next line to suit your HTML.
		url : '/HTML/home.html'
	});

	webView.addEventListener('load', function() {
		Ti.API.info("LOADING IN WEBVIEW");

	});
	PRWin.addEventListener('android:back', function(e) {
		PRWin.close();
		webView.setUrl('/HTML/indexlistingpage.html');
	});
	indexWin.addEventListener('android:back', function(e) {
		indexWin.close();
		webView.setUrl('/HTML/nearestlocationlisting.html');
	});
	var moveAway = function(e) {
		PRWin.close();
		if (e.link != 'none')
			webView.setUrl('/HTML/' + e.link);
	}
	Ti.App.addEventListener('moveAway', moveAway);
	//webView.html = webView.html;
	//webView.setWidth(50);
	Ti.App.addEventListener("injected", function() {
		alert("I'M HIT");
	});

	self.add(webView);
	self.add(activityIndicator);

	//webView.html = webView.html;
	if (animationsOn) {
		setTimeout(function() {
			webView.animate(Ti.UI.createAnimation({
				opacity : 1,
				duration : 2000
			}));
		}, 1);
	}
	function decodeLine(encoded) {
		var len = encoded.length;
		var index = 0;
		var array = [];
		var lat = 0;
		var lng = 0;

		while (index < len) {
			var b;
			var shift = 0;
			var result = 0;
			do {
				b = encoded.charCodeAt(index++) - 63;
				result |= (b & 0x1f) << shift;
				shift += 5;
			} while (b >= 0x20);
			var dlat = ((result & 1) ? ~(result >> 1) : (result >> 1));
			lat += dlat;

			shift = 0;
			result = 0;
			do {
				b = encoded.charCodeAt(index++) - 63;
				result |= (b & 0x1f) << shift;
				shift += 5;
			} while (b >= 0x20);
			var dlng = ((result & 1) ? ~(result >> 1) : (result >> 1));
			lng += dlng;

			array.push([lat * 1e-5, lng * 1e-5]);
		}

		return array;
	}

	var openPostReview = function(e) {
		var webViewTop = Ti.UI.createWebView({

			showScrollbars : false,
			top : 0,
			left : 0,
			height : '95dp',
			disableBounce : true,
			/*left : gutter,
			 top : gutter,
			 right : gutter,
			 bottom : gutter,
			 */
			layout : 'vertical',
			opacity : animationsOn ? 0 : 1,
			enableZoomControls : false, // Android only
			// Default assumes that all HTML is in the HTML folder and the first file is index.html, you can change the next line to suit your HTML.
			url : '/HTML/top.html'
		});
		var webViewBottom = Ti.UI.createWebView({

			showScrollbars : false,
			top : 0,
			left : 0,
			disableBounce : true,

			layout : 'vertical',
			opacity : animationsOn ? 0 : 1,
			enableZoomControls : false, // Android only
			// Default assumes that all HTML is in the HTML folder and the first file is index.html, you can change the next line to suit your HTML.
			url : '/HTML/bottom.html'
		});

		//PRWin.add(webViewBottom);
		webViewTop.addEventListener('load', function(e) {
			var arr = webViewTop.getUrl().split('/');
			//alert("webview loaded:"+arr[arr.length-1]);
			var actualPage = arr[arr.length - 1];
			if (actualPage.indexOf('#') > 0) {

				webViewTop.evalJS("window.location.href='top.html';");

			}
		});
		webViewBottom.addEventListener('load', function(e) {
			var arr = webViewBottom.getUrl().split('/');
			//alert("webview loaded:"+arr[arr.length-1]);
			var actualPage = arr[arr.length - 1];
			if (actualPage.indexOf('#') > 0) {

				webViewBottom.evalJS("window.location.href='bottom.html';");
			}
		});
		PRWin.add(webViewTop);
		PRWin.add(webViewBottom);
		PRWin.open();

	}
	var openIndexPage = function(e) {
		var webViewTop = Ti.UI.createWebView({
			backgroundColor : '#fed201',
			showScrollbars : false,
			top : 0,
			left : 0,
			height : '85dp',
			disableBounce : true,
			/*left : gutter,
			 top : gutter,
			 right : gutter,
			 bottom : gutter,
			 */
			layout : 'vertical',
			opacity : animationsOn ? 0 : 1,
			enableZoomControls : false, // Android only
			// Default assumes that all HTML is in the HTML folder and the first file is index.html, you can change the next line to suit your HTML.
			url : '/HTML/topforIndex.html'
		});
		var webViewBottom = Ti.UI.createWebView({

			showScrollbars : false,
			top : 0,
			left : 0,
			disableBounce : true,
			/*left : gutter,
			 top : gutter,
			 right : gutter,
			 bottom : gutter,
			 */
			layout : 'vertical',
			opacity : animationsOn ? 0 : 1,
			enableZoomControls : false, // Android only
			// Default assumes that all HTML is in the HTML folder and the first file is index.html, you can change the next line to suit your HTML.
			url : '/HTML/BottomPage.html'
		});

		//PRWin.add(webViewBottom);
		webViewTop.addEventListener('load', function(e) {
			var arr = webViewTop.getUrl().split('/');
			//alert("webview loaded:"+arr[arr.length-1]);
			var actualPage = arr[arr.length - 1];
			if (actualPage.indexOf('#') > 0) {

				webViewTop.evalJS("window.location.href='topforIndex.html';");

			}
		});
		webViewBottom.addEventListener('load', function(e) {
			var arr = webViewBottom.getUrl().split('/');
			//alert("webview loaded:"+arr[arr.length-1]);
			var actualPage = arr[arr.length - 1];
			if (actualPage.indexOf('#') > 0) {

				webViewBottom.evalJS("window.location.href='BottomPage.html';");
			}
		});
		indexWin.add(webViewTop);
		indexWin.add(webViewBottom);
		indexWin.open();

	}
	Ti.App.addEventListener('openIndexPage', openIndexPage);
	Ti.App.addEventListener('openPostReview', openPostReview);
	var openAll = function(e) {
		map.removeRoute(route);
		from = "openAll";
		var top_view = Ti.UI.createWebView({
			backgroundColor : '#fed201',
			showScrollbars : false,
			top : 0,
			left : 0,
			height : '85dp',
			disableBounce : true,
			opacity : animationsOn ? 0 : 1,
			enableZoomControls : false, // Android only
			// Default assumes that all HTML is in the HTML folder and the first file is index.html, you can change the next line to suit your HTML.
			url : '/HTML/topformap.html'
		});

		var detailsView = Ti.UI.createView({
			height : "100dp",
			backgroundImage : "lowBack.jpg"
		});
		var listview = Ti.UI.createImageView({
			top : '10dp',
			left : '90dp',
			height : '25dp',

			image : 'listview4.png',
			//title : 'dffsf'
		});
		var mapview = Ti.UI.createImageView({
			top : '8dp',
			left : '10dp',
			image : 'MapPage.png',
			height : '25dp'

			//title : 'asdasd'
		});
		var choose = Ti.UI.createLabel({
			text : 'Choose "List View" to see all locations in a list',
			color : "white",
			right : "10dp",
			top : '13dp',
			font : {
				fontSize : '3pt'
			}
		})

		var logo = Ti.UI.createImageView({
			image : 'speedcologo.png',
			left : '0dp',
			width : '100dp'
		})
		var homeBtn = Ti.UI.createButton({
			top : '10dp',
			right : '10dp',
			font : {
				fontSize : '10pt'
			},
			width : '67dp',
			height : '28dp',
			color : "white",
			backgroundImage : 'home_button.png'

		});
		var backBtn = Ti.UI.createButton({
			top : '10dp',
			right : '90dp',
			font : {
				fontSize : '10pt'
			},
			width : '67dp',
			height : '28dp',
			color : "white",
			backgroundImage : 'back_button.png'

		});

		//alert('popa reached');

		mapWin.addEventListener('android:back', function(e) {
			mapWin.close();
			webView.setUrl('/HTML/nearestlocationlisting.html');
		});
		//alert(Ti.App.cordlatitude);
		map.removeRoute(route);
		map.removeAllAnnotations();
		low_viewForOpenMap.add(choose);
		low_viewForOpenMap.add(selectedLabel)
		low_viewForOpenMap.add(detailsLabelForOpenMap);
		low_viewForOpenMap.add(getDirectionsBtn);
		low_viewForOpenMap.add(viewReviewsBtn);
		low_viewForOpenMap.add(add2favBtn);

		low_viewForOpenMap.add(callBtn);

		// code to get data from db inshallah:
		var getAnnotations = function(eMap) {
			var ann = Ti.Map.createAnnotation({
				pincolor : Ti.Map.ANNOTATION_PURPLE,
				latitude : eMap.latitudeDB,
				longitude : eMap.longitudeDB,
				image : 'pinPurple.png',
				//leftButton : '/HTML/gmaps.png',
				title : 'Speedco\n' + eMap.city + ',' + eMap.state,
				titleid : eMap.bizid
			});

			map.addAnnotation(ann);

			//map.selectAnnotation(ann);
		};

		if (!event_added) {
			Ti.App.addEventListener('updateMapLocations', getAnnotations);
			event_added = true;
		}
		mapWin.addEventListener('close', function(eClose) {
			Ti.App.removeEventListener('updateMapLocations', getAnnotations);
			//map=null;
			Ti.App.fireEvent('removeAgain', {});
			event_added = false;

		});

		// map already opened then dont fire.. take a value
		Ti.App.fireEvent('getFeedPage', {
			'srcFire' : 'map'
		});
		//alert('going on to setLoca');
		var currentPositionZoomedOut = {
			latitude : Ti.App.cordlatitude,
			longitude : Ti.App.cordlongitude,
			animate : true,
			regionFit : true,
			latitudeDelta : 0.5,
			longitudeDelta : 0.5
		};
		map.setLocation(currentPositionZoomedOut);
		mapWin.add(map);
		//top_view.add(logo);
		//top_view.add(backBtn);
		//top_view.add(homeBtn);
		low_viewForOpenMap.add(listview);
		low_viewForOpenMap.add(mapview);
		//low_view.add(choose);
		mapWin.add(low_viewForOpenMap);
		mapWin.add(top_view);
		mapWin.open();
		Ti.App.fireEvent('hideLoading', {});
		backBtn.addEventListener('click', function(e) {
			webView.setUrl('/HTML/nearestlocationlisting.html');
			Ti.App.fireEvent('removeAgain', {});
			mapWin.close();
		});
		getDirectionsBtn.addEventListener('click', function(e) {
			//alert(selectedLat);
			//alert(selectedLong);

			Ti.App.fireEvent('showLoading', {});
			//alert(selectedAdd);
			webView.evalJS("localStorage['getdirectionbacklink']='nearestlocationlisting.html';");
			//mapWin.close();
			webView.evalJS("localStorage['storeDestLat']='" + selectedLat + "';");
			webView.evalJS("localStorage['storeDestLong']='" + selectedLong + "';");
			webView.evalJS("localStorage['storeCity']='" + selectedCity + "';");
			webView.evalJS("localStorage['storePh']='" + selectedTel + "';")
			webView.evalJS("localStorage['storeName']='Speedco " + selectedID + "';");
			webView.evalJS("localStorage['storeState']='" + selectedState + "';");
			webView.evalJS("localStorage['storeAdd']='" + selectedAdd + "';");
			//alert("before firing:"+selectedLat+" "+selectedLong+" "+selectedAdd+","+selectedCity+" "+selectedTel+" "+selectedID);
			setTimeout(function(e) {
				webView.evalJS("window.location.href='getdirections.html';");
			}, 1000);
			//webView.setUrl('/HTML/getdirections.html');
			Ti.App.fireEvent('removeAgain', {});
			mapWin.close();
			Ti.App.fireEvent('showLoading', {});
		});
		viewReviewsBtn.addEventListener('click', function(e) {
			webView.evalJS("localStorage['ilpg_QString'] = " + selectedID + ";");
			webView.evalJS("window.location.href = 'reviewlist.html';");
			Ti.App.fireEvent('removeAgain', {});
			mapWin.close();
		});
		callBtn.addEventListener('click', function(e) {
			if (selectedTel.charAt(0) == 'L') {
				selectedTel = selectedTel.slice(2, 16);
				//alert(selectedTel);
			}
			Ti.App.fireEvent('TiPlat', {
				'url' : 'tel:' + selectedTel
			});
			//webView.evalJS("window.location.href='tel:+"+selectedTel+"';");
			//mapWin.close();
		});
		homeBtn.addEventListener('click', function(e) {
			webView.setUrl('/HTML/home.html');
			Ti.App.fireEvent('removeAgain', {});
			mapWin.close();
		});
		listview.addEventListener('click', function(e) {
			//webView.evalJS("localStorage['directionlistbacklink'] = 'getdirections.html';localStorage['locfrm'] = 'test';window.location.href = 'directionlist.html'");
			webView.setUrl('/HTML/nearestlocationlisting.html');
			Ti.App.fireEvent('removeAgain', {});
			mapWin.close();
		});
		add2favBtn.addEventListener('click', function(e) {

			webView.evalJS('localStorage["favorites"]=localStorage["favorites"]+","+' + selectedID + ';');
			//webView.evalJS('alert("Done. Added to favourites.");');
			webView.evalJS('var favNow=localStorage["favorites"];Ti.App.fireEvent("fav2db",{data:favNow});');
			Ti.App.fireEvent('showAlert', {
				'msg' : 'Done. Added to favorites.'
			});
		});
	}
	var f = function(eSuper) {
		from = "f";
		var org_lat = "";
		var org_lon = "";

		try {
			var patch = Ti.UI.createView({
				backgroundColor : 'green',
				width : Ti.UI.SIZE,
				height : Ti.UI.SIZE,
				top : '20dp',
				right : '0dp'

			});
			//alert('reached here..');
			var detailsLabel = Ti.UI.createLabel({
				text : eSuper.name + "\n" + eSuper.add + "," + eSuper.city + "\n" + eSuper.tel,
				color : "blue",
				top : '35dp',
				right : '15dp',
				font : {
					fontSize : '5pt'
				}
			});
			/*
			 var detailsLabel = Ti.UI.createLabel({
			 text : "\n" + eSuper.name + "\n" + eSuper.add + "," + eSuper.city + "\n" + eSuper.tel,
			 //html:"<span style='margin-left:\'30px\''>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br/><br/>" + eSuper.name + "<br/>" + eSuper.add + "," + eSuper.city + "<br/>" + eSuper.tel+"</span>",
			 color : "blue",
			 top : '0dp',
			 //left : 'dp',
			 right : '0dp',
			 textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT,
			 font : {
			 fontSize : '5pt'
			 }
			 });*/

			var top_view = Ti.UI.createView({
				top : "0dp",
				height : "100dp",
				width : "100%",
				backgroundImage : "backgrnd.jpg"
			});
			var low_view = Ti.UI.createView({
				backgroundImage : "lowBack.jpg",
				height : "50dp", //88dp
				bottom : "0dp"
			});

			var detailsView = Ti.UI.createView({
				height : "100dp",
				backgroundImage : "lowBack.jpg"
			});
			var listview = Ti.UI.createImageView({
				top : '10dp',
				left : '10dp',
				height : '25dp',
				image : 'Directions.png',
				//title : 'dffsf'
			});
			var mapview = Ti.UI.createImageView({
				top : '10dp',
				left : '110dp',
				image : 'MapPage.png',
				height : '25dp'
				//title : 'asdasd'
			});
			var choose = Ti.UI.createLabel({
				text : "Choose Map View to see all.",
				color : "white",
				right : "10dp",
				font : {
					fontSize : '10pt'
				}
			})
			var logo = Ti.UI.createImageView({
				image : 'speedcologo.png',
				left : '0dp',
				width : '100dp'
			})
			var homeBtn = Ti.UI.createButton({
				top : '10dp',
				right : '10dp',
				font : {
					fontSize : '10pt'
				},
				color : "white",
				width : '51dp',
				height : '23dp',
				backgroundImage : 'home_button.png'

			});
			var backBtn = Ti.UI.createButton({
				top : '10dp',
				right : '70dp',
				font : {
					fontSize : '10pt'
				},
				width : '51dp',
				height : '23dp',
				color : "white",
				backgroundImage : 'back_button.png'

			});

			//var map = "";
			Ti.Geolocation.preferredProvider = Titanium.Geolocation.PROVIDER_GPS;
			Ti.Geolocation.purpose = "Speedco";
			Titanium.Geolocation.accuracy = Titanium.Geolocation.ACCURACY_BEST;

			//
			//  SET DISTANCE FILTER.  THIS DICTATES HOW OFTEN AN EVENT FIRES BASED ON THE DISTANCE THE DEVICE MOVES
			//  THIS VALUE IS IN METERS
			//
			Titanium.Geolocation.distanceFilter = 10;
			storeLatitude = eSuper.storeLat;
			storeLongitude = eSuper.storeLong;

			Ti.Geolocation.getCurrentPosition(function(evt) {
				var currentPositionZoomed = {
					latitude : evt.coords.latitude,
					longitude : evt.coords.longitude,
					animate : true,
					regionFit : true,
					latitudeDelta : 0.05,
					longitudeDelta : 0.05
				};
				map.setLocation(currentPositionZoomed);
				/*map = Ti.Map.createView({
				 mapType : Titanium.Map.STANDARD_TYPE,
				 region : {
				 latitude : evt.coords.latitude,
				 longitude : evt.coords.longitude,
				 latitudeDelta : 0.05,
				 longitudeDelta : 0.05
				 },

				 animate : true,
				 regionFit : true,
				 userLocation : true
				 });*/
				cLat = evt.coords.latitude;
				cLon = evt.coords.longitude;
				des_lat = eSuper.Lat;
				des_lon = eSuper.Lon;
				var origin = String(evt.coords.latitude + ',' + evt.coords.longitude), travelMode = 'driving', yourLatitude = eSuper.Lat, yourLongitude = eSuper.Lon, destination = String(yourLatitude + ',' + yourLongitude), url = "http://maps.google.com/maps/api/directions/xml?mode=" + travelMode + "&origin=" + origin + "&destination=" + destination + "&sensor=false";
				xhr = Titanium.Network.createHTTPClient();
				xhr.open('GET', url);
				//alert("url before sending:" + url);
				Ti.API.info('>>> go get data for Rgeocode! ...URL: ' + url);

				xhr.onload = function(e) {
					//alert(url);
					//alert(this.responseText);
					var xml = this.responseXML, points = [], steps = xml.documentElement.getElementsByTagName("step"), totalSteps = steps.length;
					Ti.API.info("responseXML was:" + xml);
					htmlInstructions = "";
					Mileage = "";
					for (var i = 0; i < totalSteps; i++) {
						var polylineString = steps.item(i).getElementsByTagName("polyline").item(0).getElementsByTagName("points").item(0).text, decodedPolyline = decodeLine(polylineString);
						htmlInstructions += "<tr><td><b>" + (i + 1) + ".</b></td><td>" + steps.item(i).getElementsByTagName("html_instructions").item(0).text + "</td><td></td><td width='80px'>" + steps.item(i).getElementsByTagName("distance").item(0).getElementsByTagName("text").item(0).text + "</td></tr>";
						for (var j = 0; j < decodedPolyline.length; j++) {
							if (decodedPolyline[j] != null) {
								points.push({
									latitude : decodedPolyline[j][0],
									longitude : decodedPolyline[j][1]
								});
							}
						}
					}

					// Get last point and add it to the array, as we are only parsing <start_location>
					try {
						var finalLocation = steps.item(totalSteps - 1).getElementsByTagName("end_location"), finalLatitude = finalLocation.item(0).getElementsByTagName("lat").item(0).text, finalLongitude = finalLocation.item(0).getElementsByTagName("lng").item(0).text;
					} catch(e) {
						//alert('BIG ERROR! while calculating finallocation in getdirections map:' + e);
						webView.setUrl('/HTML/nearestlocationlisting.html');
					}
					points.push({
						latitude : finalLatitude,
						longitude : finalLongitude
					});

					// Create route and annotations
					route = {
						name : "bonVoyage",
						points : points,
						color : "blue",
						width : 6
					}, startAnnotation = Ti.Map.createAnnotation({
						pincolor : Ti.Map.ANNOTATION_GREEN,
						latitude : points[0].latitude,
						longitude : points[0].longitude,
						leftButton : '/HTML/gmaps.png',
						image : 'pinGreen.png',
						title : 'Current Location\nClick on the icon to open in Maps'
					}), endAnnotation = Ti.Map.createAnnotation({
						pincolor : Ti.Map.ANNOTATION_RED,
						latitude : points[points.length - 1].latitude,
						longitude : points[points.length - 1].longitude,
						leftButton : '/HTML/gmaps.png',
						image : 'pinRed.png',
						title : 'Speedco \n' + eSuper.add + '\n' + eSuper.city + '\nClick on the icon to open in Maps'
					});
					/*
					endAnnotation.addEventListener('click', function(e) {
					//doesnt work so changed it a bit.Refer:http://stackoverflow.com/questions/12539009/current-location-doesnt-work-with-apple-maps-ios-6

					webView.evalJS("var fireString = '';var is_iOS6 = /iPhone OS 6_0/i.test(navigator.userAgent);if (is_iOS6)fireString = 'http://maps.apple.com/maps?xyz=xyz&daddr=' + " + yourLatitude + " + ',' + " + yourLongitude + ";else fireString = 'http://maps.google.com/maps?xyz=xyz&saddr=' + " + evt.coords.latitude + " + ',' + " + evt.coords.longitude + " + '&daddr=' + " + yourLatitude + " + ',' + " + yourLongitude + ";Ti.App.fireEvent('TiPlat', {url : fireString});");

					})*/
					/*map.addEventListener('click', function(e) {
					//alert('map click was caught:'+e.clicksource);
					// if user click on rightButton of annotaion
					if (e.clicksource == 'leftPane') {
					//Ti.API.info("Opening detail window");
					//alert("detailed");
					fireString = 'http://maps.google.com/maps?xyz=xyz&saddr=' + evt.coords.latitude + ',' + evt.coords.longitude + '&daddr=' + yourLatitude + ',' + yourLongitude;
					Ti.App.fireEvent('TiPlat', {
					url : fireString
					});
					//webView.evalJS("var fireString = '';var is_iOS6 = /iPhone OS 6_0/i.test(navigator.userAgent);if (is_iOS6)fireString = 'http://maps.apple.com/maps?xyz=xyz&daddr=' + " + yourLatitude + " + ',' + " + yourLongitude + ";else fireString = 'http://maps.google.com/maps?xyz=xyz&saddr=' + " + evt.coords.latitude + " + ',' + " + evt.coords.longitude + " + '&daddr=' + " + yourLatitude + " + ',' + " + yourLongitude + ";Ti.App.fireEvent('TiPlat', {url : fireString});");

					}
					});*/
					// Add elements
					map.removeAllAnnotations();
					map.removeRoute(route);
					//map.selectAnnotation(endAnnotation);
					map.addRoute(route);
					map.addAnnotation(startAnnotation);
					map.addAnnotation(endAnnotation);
					map.selectAnnotation(startAnnotation);
					Ti.App.fireEvent('hideLoading', {});
					/*setTimeout(function() {
					 map.regionFit = true;
					 }, 700);
					 //hack to get route to show*/
				};

				xhr.send();
			});
			//map.zoom(2);
			/*map.setLocation = {
			 latitude : storeLatitude,
			 longitude : storeLongitude,
			 latitudeDelta : 0.1,
			 longitudeDelta : 0.1
			 };*/

			mapWin1.addEventListener('close', function(eClose) {
				//Ti.App.removeEventListener('updateMapLocations', getAnnotations);
				//	mapWin=null;
				//map=null;
				//Ti.Android.currentActivity.finish();
				// map.onClose();
				//win.close();
				//Ti.Android.currentActivity.fireEvent('destroy',{});
				//mapWin1.fireEvent('android:back',{});
				var arr = webView.getUrl().split('/');
				//alert("webview loaded:"+arr[arr.length-1]);
				var actualPage = arr[arr.length - 1];
				//alert("loading");if (arr[arr.length - 1] == "home.html")
				//alert(webView.getUrl());
				//alert('actual page was:'+actualPage);
				if (webView.canGoBack() && actualPage != "home.html" && actualPage != "directionlist.html") {
					webView.evalJS(" window.location.href=localStorage['getdirectionbacklink'];");
				}
			});
			logo.addEventListener('click', function(e) {
				mapWin1.close();
				webView.evalJS(" window.location.href='home.html';");
			})
			mapWin1.add(map);
			top_view.add(logo);
			top_view.add(backBtn);
			top_view.add(homeBtn);
			//patch.add(detailsLabel)
			top_view.add(detailsLabel);
			low_view.add(listview);
			low_view.add(mapview);
			//low_view.add(choose);
			mapWin1.add(low_view);
			mapWin1.add(top_view);
			mapWin1.open();
			win = Ti.UI.currentWindow;
			backBtn.addEventListener('click', function(e) {
				mapWin1.close();
			});

			homeBtn.addEventListener('click', function(e) {
				webView.setUrl('/HTML/home.html');
				mapWin1.close();
			});
			listview.addEventListener('click', function(e) {
				//webView.evalJS("window.location.href = 'directionlist.html';");
				webView.setUrl('/HTML/directionlist.html');
				mapWin1.close();
			});

		} catch(e) {
			alert(e);
		}
	}
	var moveAwayMap = function(e) {
		mapWin.close();
		if (e.link != 'none')
			webView.setUrl('/HTML/' + e.link);
	}
	Ti.App.addEventListener('moveAwayMap', moveAwayMap);
	var moveAwayIndex = function(e) {
		indexWin.close();
		if (e.link != 'none')
			webView.setUrl('/HTML/' + e.link);
	}
	Ti.App.addEventListener('moveAwayIndex', moveAwayIndex);
	var moveAwayGD = function(e) {
		mapWin1.close();
		if (e.link != 'none')
			webView.setUrl('/HTML/' + e.link);
	}
	Ti.App.addEventListener('moveAwayGD', moveAwayGD);
	Ti.App.addEventListener('getHTMLdirections', function(e) {
		Ti.App.fireEvent('setDirectionsHTML', {
			'html' : htmlInstructions
		});
		//htmlInstructions="";
	});

	Ti.App.addEventListener('popa', f);

	Ti.App.addEventListener('showAlert', function(e) {
		Titanium.UI.createAlertDialog({

			message : e.msg,
			ok : 0,
			buttonNames : ['OK']
		}).show();
	});

	Ti.App.addEventListener('addAgain', function(e) {
		//alert('added openMap:'+openMap_event_added);
		//Ti.App.addEventListener('updateMapLocations', getAnnotations);
		//Ti.App.fireEvent('addOpenAll',{});
		if (!openMap_event_added) {
			Ti.App.addEventListener('openMapLocationPage', openAll);
			openMap_event_added = true;
		}
	});
	

	Ti.App.addEventListener('removeAgain', function(e) {
		//alert('removed');
		//Ti.App.fireEvent('removeOpenAll',{});
		//Ti.App.removeListener('updateMapLocations', getAnnotations);
		Ti.App.removeEventListener('openMapLocationPage', openAll);
		openMap_event_added = false;
	});

	// Load the platform specific UI.
	var ApplicationWindowPlatform;
	if (Ti.Platform.osname == 'mobileweb') {
		// Work around missing platform-specific require feature in Mobile Web.
		ApplicationWindowPlatform = require('mobileweb/ui/ApplicationWindowPlatform');
	} else {
		ApplicationWindowPlatform = require('ui/ApplicationWindowPlatform');
	}
	ApplicationWindowPlatform(self, webView, titleBarOn, drawerOn);

	return self;
}

//make constructor function the public component interface
module.exports = ApplicationWindow;
