/*
 * HTML Application Template:
 * A basic starting point for your application.  Mostly a blank canvas with a web view.
 *
 * In app.js, we generally take care of a few things:
 * - Bootstrap the application with any data we need
 * - Check for dependencies like device type, platform version or network connection
 * - Require and open our top-level UI component
 *
 */

var htmlInstructions = "";
var lastCheckedDate = "";
var injected = false;
Ti.App.localarr = "[";
var newFile = Titanium.Filesystem.getFile(Ti.Filesystem.applicationDataDirectory, 'Settings.txt');
var _cordinates = [];
_cordinates.latitude = "";
_cordinates.longitude = "";

function zipToLatLong(e) {
	var xhr = Titanium.Network.createHTTPClient();
	var url = 'http://maps.googleapis.com/maps/api/geocode/xml?address=' + e.add + '&sensor=false';
	xhr.open("GET", url);
	xhr.send();
	xhr.onload = function() {
		Ti.API.info('RAW =' + this.responseText);
		if (this.status == '200') {
			Ti.API.info('got my response, http status code ' + this.status);
			if (this.readyState == 4) {
				var ResponseXML = this.responseText;
				//alert('from html..zipToLatLong was called..responseMade..now firing ziptoLatFire on html');
				Ti.App.fireEvent('zipToLatFIRE', {
					'xml' : ResponseXML
				});
			} else {
				//alert('HTTP Ready State != 4');
			}
		} else {
			//alert('HTTp Error Response Status Code = ' + this.status);
			Ti.API.error("Error =>" + this.response);
		}
	};
}

function reviews(e) {
	var xhr = Titanium.Network.createHTTPClient();
	//var url = 'http://maps.googleapis.com/maps/api/geocode/xml?address=' + e.add + '&sensor=false';
	var url = e.url;
	Ti.API.info('getReviews called with URL:' + url);
	xhr.open("GET", url);
	xhr.send();
	xhr.onload = function() {
		Ti.API.info('RAW =' + this.responseText);
		if (this.status == '200') {
			Ti.API.info('got my response, http status code ' + this.status);
			if (this.readyState == 4) {
				Ti.API.info('enterred ready state');
				var ResponseText = this.responseText;
				Ti.App.fireEvent('putReviews', {
					'ResponseText' : ResponseText
				});
			} else {
				Ti.API.info('HTTP Ready State != 4');
				//alert('HTTP Ready State != 4');
			}
		} else {
			//alert('HTTp Error Response Status Code = ' + this.status);
			Ti.API.error("Error =>" + this.response);
		}
	};
}

function getDate() {
	Ti.API.info('getDate was called to write newFile');
	var currentTime = new Date();
	var hours = currentTime.getHours();
	var minutes = currentTime.getMinutes();
	var month = currentTime.getMonth() + 1;
	var day = currentTime.getDate();
	var year = currentTime.getFullYear();
	return year + "-" + month + "-" + day + " " + hours + ":" + minutes;
	//   return hours +":"+minutes + " - "+day+"/"+month+"/"+year;
}

if (newFile.exists()) {

	//newFile.write('2012-');
	lastCheckedDate = newFile.read().text;
	Ti.API.info('newfile: ' + newFile.read());

}

function sendReq() {
	var xhr = Titanium.Network.createHTTPClient();
	xhr.onerror = function(e) {
		Ti.API.error('Bad Sever =>' + e.error);
	};
	if (lastCheckedDate == "")
		lastCheckedDate = "1970-01-01 00:00";
	//var url="http://www.ammultitrade.com/handler/RequestHandler.ashx?action=CheckDB&dt="+Ti.Network.encodeURIComponent(lastCheckedDate);
	if (newFile.exists()) {
		//var params = "{'dt':'"+newFile.read()+"'}";
		var params = {
			"dt" : "" + lastCheckedDate + ""
		};
	} else {
		var params = {
			"dt" : "1970-01-01 00:00"
		};
	}
	//{"dt":"2001-01-01 00:00"}
	//JSON.stringify(params);
	var url = "http://apphost.speedco.com/handler/RequestHandler.ashx?action=CheckDB&dtPost=" + JSON.stringify(params) + "";

	xhr.open("POST", url);
	//ADD your URL
	//xhr.setRequestHeader("content-type", "application/x-www-form-urlencoded");
	Ti.API.info('url was:' + url);
	Ti.API.info('dt was:' + lastCheckedDate);
	//Ti.API.info('Params' + param);
	//	var params = { "dt": lastCheckedDate };
	//JSON.stringify(params);
	//xhr.send(params);
	xhr.send();
	xhr.onload = function() {
		Ti.API.info('RAW =' + this.responseText);
		if (this.status == '200') {
			Ti.API.info('got my response, http status code ' + this.status);
			if (this.readyState == 4) {
				//insert to db
				if (this.responseText != "NO") {
					//write to db
					//try{
					try {

						var db2insert = Ti.Database.install('speedco.db', 'storeDB');

						Ti.API.info('going to execute delete');

						db2insert.execute('delete from stores');

						Ti.API.info('delete executed now closin and ..');

						//rows2.close();

						Ti.API.info('..going to execute inserts');

						var sqlArray = this.responseText.split('~|~');

						for (var i = 0; i < (sqlArray.length - 1); i++) {

							db2insert.execute(sqlArray[i]);

						}

						//db2insert.execute(this.responseText);

						Ti.API.info('inserts over now closing');

						//rows3.close();

						newlyDownloaded = true;

						db2insert.close();

						Ti.API.info('came here going to fire kholikhali');

						Ti.App.fireEvent('kholiKhaliKar', {});

					} catch(e) {

						Ti.API.info('E R R O R:' + e);

					}

				}

			} else {
				// alert('hiding the loading..');
				// Ti.App.fireEvent('hideLoading', {});

			}
		} else {
			//alert('HTTp Error Response Status Code = ' + this.status);
			Ti.API.error("Error =>" + this.response);
		}

	};

	newFile.write(getDate());
	//setTimeout(function(e){alert("new file written with date:"+getDate())},4000);
}

sendReq();
//var newFile = Titanium.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, 'Settings.txt');

/*else
 {
 newFile.createFile();
 newFile.write(getDate());
 }*/

Ti.App.addEventListener('openFB', function(e) {
	//alert('departed called '+e.use);
	//alert(Ti.Platform.canOpenURL(e.use));
	Ti.Platform.openURL('http://m.facebook.com/speedcopm');
	//return true;
});
Ti.App.addEventListener('openTwitter', function(e) {
	//alert('departed called '+e.use);
	//alert(Ti.Platform.canOpenURL(e.use));
	Ti.Platform.openURL('https://mobile.twitter.com/SpeedcoPM');
	//return true;
});
var injected = false;

var feeds = '';

var createLis = function(e) {
	//if (injected)
	{
		var rows = "";
		var feedHTML = "";
		//alert(e.st);
		var db = Ti.Database.install('speedco.db', 'storeDB');
		Ti.API.info("going to fire with:" + e.st);
		if (e.by == "fav") {
			rows = db.execute('Select * from stores where Store in(' + e.st + ')');
		} else
			rows = db.execute('Select * from stores where Store=' + e.st);
		//alert("create");
		while (rows.isValidRow()) {
			//alert("was valid");
			feedHTML += "";
			var bizid = rows.fieldByName('Store');
			var city = rows.fieldByName('City');
			var state = rows.fieldByName('ST');
			var Lat = rows.fieldByName('Latitude');
			var Long = rows.fieldByName('Longitude');
			var idx = bizid.toString();
			if (e.by == "2") {
				Ti.API.info("making feeds2 for:" + e.st);
				feeds = feeds + "<li><a class='k' href='#' style='width:17%; display:inline-block; padding-left:1%; text-align:center;float:left; overflow:hidden;  height:40px' onclick='change(" + idx + ")'><div style='float:left; overflow:hidden;  height:30px' id=" + idx + " class='star' ></div></a><div  onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><div  onclick='try{xback(" + idx + ");}catch(e){alert(e);}' style='display:block;width:36%; padding-left:1%; float:left;overflow:hidden'>Speedco " + bizid + "<br/>" + city + ", " + state + "<br/></div><div style='width:45%; height:30px; display:inline-block;float:right; overflow:hidden'><a href='#' onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><img src='Newfolder/IndexListingdetailsarrow.png' align='right'/></a></div></div></li>";

			} else if (e.by == "fav") {
				feeds = feeds + "<li><div  onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><div  onclick='try{xback(" + idx + ");}catch(e){alert(e);}' style='display:block;width:36%; padding-left:10%; float:left;overflow:hidden'>Speedco " + bizid + "<br/>" + city + ", " + state + "<br/></div><div style='width:45%; height:63px; display:inline-block;float:right; overflow:hidden'><a href='#' onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><img src='Newfolder/IndexListingdetailsarrow.png' align='right'/></a></div></div></li>";

			} else {
				//alert('fired:'+bizid);
				feeds = feeds + "<li><a class='k' href='#' style='width:17%; display:inline-block; padding-left:1%; text-align:center;float:left; overflow:hidden;  height:40px' onclick='change(" + idx + ")'><div style='float:left; overflow:hidden;  height:30px' id=" + idx + " class='star' ></div></a><div  onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><div  onclick='try{xback(" + idx + ");}catch(e){alert(e);}' style='display:block;width:36%; padding-left:1%; float:left;overflow:hidden'>Speedco " + bizid + "<br/>" + city + ", " + state + "<br/></div><div style='width:45%; height:30px; display:inline-block;float:right; overflow:hidden'><a href='#' onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><img src='Newfolder/IndexListingdetailsarrow.png' align='right'/></a></div></div></li>";

				//feeds = feeds + "<li><a class='k' href='#' style='width:17%; display:inline-block; padding-left:1%; text-align:center;float:left; overflow:hidden;  height:63px' onclick='change(" + idx + ")'><div style='float:left; overflow:hidden;  height:63px' id=" + idx + " class='star' ></div></a><div  onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><div onclick='try{xback(" + idx + ");}catch(e){alert(e);}' style='display:block;width:36%; padding-left:1%; float:left;overflow:hidden'>Speedco" + bizid + "<br/>" + city + ", " + state + "<br/></div><div style='width:45%; height:63px; display:inline-block;float:right; overflow:hidden'><a href='#' onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><img src='Newfolder/IndexListingdetailsarrow.png' align='right'/></a></div></div></li>";
			}
			rows.next();
		}
		rows.close();
		db.close();
		var runned = false;
		if ((e.v == "done" && !runned ) || (e.v == "done" && e.by == 'fav')) {
			try {
				//alert(feeds);

				if (e.by == "2") {
					Ti.API.info("going to fire feeds2:" + feeds);
					Ti.App.fireEvent('finishFeed2', {
						'feedItem' : feeds
					});

				} else if (e.by == "fav") {
					//alert("going to fire finishFav:" + feeds);
					Ti.App.fireEvent('finishFav', {
						'feedItem' : feeds
					});
				} else {
					//alert("going to fire finishFeed:" + feeds);
					Ti.API.info("going to fire finishFeed:" + feeds);
					Ti.App.fireEvent('finishFeed', {
						'feedItem' : feeds
					});
				}
				feeds = '';
				runned = true;
			} catch(e) {
				alert('createLis:' + e);
			}
		}
	}
}
function getDiscount(str) {

	//return ResponseText;
}

var fillServices = function(e) {
	var tireToWrite = "";
	var lubeToWrite = "";
	var federalToWrite = "";
	var dbJson = Ti.Database.install('speedco.db', 'storeDB');
	if (e.data != 'NONE') {
		var json = JSON.parse(e.data);
		var tire = json.tire;
		var federal = json.federal;
		//alert(federal);
		var lube = json.lube;

		//alert(e.st);
		//var db = Ti.Database.install('speedco.db', 'storeDB');

		dbJson.execute("update lube SET html=?", lube);
		dbJson.execute("update federal SET html=?", federal);
		dbJson.execute("update tire SET html=?", tire);
	}
	var tFromDB = dbJson.execute('SELECT html FROM tire');
	if (tFromDB.isValidRow()) {
		tireToWrite = tFromDB.fieldByName('html');

	}

	var lFromDB = dbJson.execute('SELECT html FROM lube');
	if (lFromDB.isValidRow()) {
		lubeToWrite = lFromDB.fieldByName('html');

	}
	var fFromDB = dbJson.execute('SELECT html FROM federal');
	if (fFromDB.isValidRow()) {
		federalToWrite = fFromDB.fieldByName('html');

	}

	dbJson.close();

	Ti.App.fireEvent('loadToStorage', {
		'lube' : lubeToWrite,
		'tire' : tireToWrite,
		'fed' : federalToWrite
	});

	//}
}
var createListPage = function(e) {
	//alert(e.srcFire);
	//if (injected) WAS UNCOMMENTED AND WORKING FINE UNTILL ON 21st NOV WHEN IT WAS COMMENTED
	//FOR SUPPORTING MULTIEVENTFIRES

	//var discText = "";
	var discountText = "";
	var discountPic = "";
	//alert(e.srcFire);
	var feedHTML = "";
	var rows;
	var timer = 0;
	var db = Ti.Database.install('speedco.db', 'storeDB');
	if (e.srcFire == "index") {
		timer = 1000;
		rows = db.execute('SELECT * FROM stores where Store=' + e.st);

		var xhr = Titanium.Network.createHTTPClient();
		//var url = 'http://maps.googleapis.com/maps/api/geocode/xml?address=' + e.add + '&sensor=false';
		var url = 'http://apphost.speedco.com/handler/RequestHandler.ashx?action=Disc&sid=' + e.st;
		//alert(url);
		Ti.API.info('getDiscount called with URL:' + url);
		xhr.open("GET", url);
		xhr.send();
		xhr.onload = function() {
			Ti.API.info('RAW =' + this.responseText);
			if (this.status == '200') {
				Ti.API.info('got my response, http status code ' + this.status);
				if (this.readyState == 4) {
					Ti.API.info('enterred ready state');
					var res = this.responseText;
					//alert(res);
					discountText = res;
					//alert(discountText);
					//discountPic = res.split('|')[1];
					//alert(discountPic);
					//alert(ResponseText);
					//alert(ResponseText);
				} else {
					Ti.API.info('HTTP Ready State != 4');
					//discountText="Not Ready";
					//alert('HTTP Ready State != 4');
					//alert(ResponseText);
				}
			} else {
				//alert('HTTp Error Response Status Code = ' + this.status);
				Ti.API.error("Error =>" + this.response);
				//discountText="error";
				//alert(ResponseText);
			}
		};
	} else if (e.srcFire == "map")
		rows = db.execute('SELECT * FROM stores');
	//alert("create");
	/*if (e.srcFire == "index") {
	 while (discountText == "") {
	 alert('loop');
	 }
	 }*/
	setTimeout(function(ef) {
		while (rows.isValidRow()) {
			//feedHTML += "";
			//var idx = bizid.substring(8);
			var bizid = rows.fieldByName('Store');
			var sadd = rows.fieldByName('Address');
			var city = rows.fieldByName('City');
			var state = rows.fieldByName('ST');
			var postal = rows.fieldByName('ZIP');
			var telph = rows.fieldByName('Phone');
			var destLat = rows.fieldByName('Latitude');
			var destLong = rows.fieldByName('Longitude');
			var DayInfo1 = rows.fieldByName('DayInfo1');
			var TimeInfo1 = rows.fieldByName('TimeInfo1');
			var DayInfo2 = rows.fieldByName('DayInfo2');
			var TimeInfo2 = rows.fieldByName('TimeInfo2');
			var DayClosedInfo = rows.fieldByName('DayClosedInfo');

			var TireService = rows.fieldByName('Tire Store');
			//alert('TireService'+TireService);
			var LubeService = rows.fieldByName('LS');
			//alert('LubeService'+LubeService);
			var AnnualServices = rows.fieldByName('AI');
			//alert('AnnualServices'+AnnualServices);
			if (telph.charAt(0) == 'L') {
				telph = telph.slice(2, 16);
				//alert(selectedTel);
			}
			//need to fix L & T
			var service = "Speedco Truck Lube and Tire"
			var idx = bizid;
			//feedHTML = feedHTML + "<li><div style='width:36%; padding-left:1%; float:left;overflow:hidden'>Speedco" + bizid + "<br/>" + city + ", " + state + "<br/></div><a class='k' href='#' style='width:17%; display:inline-block; padding-left:1%; text-align:center;float:left; overflow:hidden;  height:63px' onclick='change(" + idx + ")'><div style='float:left; overflow:hidden;  height:63px' id=" + idx + " class='star' ></div></a><div style='width:45%; height:63px; display:inline-block;float:right; overflow:hidden'><a href='#' onclick='try{xback(" + idx + ");}catch(e){alert(e);}' ><img src='Newfolder/IndexListingdetailsarrow.png' align='right'/></a></div></li>";
			feedHTML = feedHTML + '<div class="head3"  ><div class="head3left">';
			feedHTML = feedHTML + '<span >Speedco ' + bizid + '</span><br />';
			feedHTML = feedHTML + sadd + '<br />';
			feedHTML = feedHTML + city + ',' + state + ' ' + +postal + '<br /></div>';

			//feedHTML = feedHTML + '<div class="head3right" >'+WorkingHourLine1+'<br />'+WorkingHourLine2+'<br />'+WorkingHourLine3+'<br />';
			feedHTML = feedHTML + '<div class="head3right" >' + DayInfo1 + '<br/>' + TimeInfo1 + '<br />' + DayInfo2 + '<br/>' + TimeInfo2 + '<br />' + DayClosedInfo + '<br />';
			feedHTML = feedHTML + '</div><div id="fu" class="starry"  onclick="changeRow(' + idx + ')"><img id="pic" style="padding-right:10px" src="stupstar.png" /></div></div>';

			feedHTML = feedHTML + '<div class="curvebox"><ul class="curvebox">';
			if (TireService == "yes")//(service.indexOf('Tire') >= 0)
				feedHTML = feedHTML + '<li><a href="#" onclick="tire()"><span style="height:33px; width:35px; float:left; margin-top:10px;"><img src="Newfolder/IndexListingPagetire.png" /></span> tire service available</a></li>';
			if (LubeService == "yes")//(service.indexOf('Lube') >= 0)
				feedHTML = feedHTML + '<li><a href="#" onclick="lube()"><span style="height:33px; width:35px; float:left; margin-top:10px;"><img src="Newfolder/IndexListingPagelube.png" /></span> lube service available</a></li>';
			if (AnnualServices == "yes")//(service.indexOf('Lube') >= 0)
				feedHTML = feedHTML + '<li><a href="#" onclick="annual()"><span style="height:33px; width:35px; float:left; margin-top:10px;"><img src="Newfolder/annual.png" /></span> inspection service available</a></li>';
			feedHTML = feedHTML + '<li><a href="#" onclick="xback(' + bizid + ')"><span style="height:33px; width:35px; float:left; margin-top:10px;"><img src="Newfolder/IndexListingPagemap.png" /></span>get directions</a></li>';
			feedHTML = feedHTML + '<li><a href="#" onclick="postback()"><span style="height:33px; width:35px; float:left; margin-top:10px;"><img src="Newfolder/IndexListingPagefeedbac.png" /></span>post review</a></li>';
			feedHTML = feedHTML + '<li><a href="#" onclick="LocFavadd(' + bizid + ');"  ><span style="height:33px; width:35px; float:left; margin-top:10px;"><img src="Newfolder/IndexListingPagestar.png"  height="30" width="28"/></span>add to favorites</a></li>';
			if (discountText != "NONE") {
				//alert(discountPic.toString());
				//var ap ="aap"
				//var json = JSON.parse(discountText);
				//alert(JSON.stringify(json));
				//alert(discountText.toString());
				feedHTML = feedHTML + "<li onclick=\"xbar('" + discountText.toString() + "');\" ><a href='#'><span style='height:33px; width:35px; float:left; margin-top:10px;'><img src=\"Newfolder/discount_icon.png\" /> </span>Discounts Available</a></li>";
			} else {

				//alert('response was:' + discountText);

				//alert(discountText);

			}
			feedHTML = feedHTML + '</ul></div>';
			feedHTML = feedHTML + '<div style="width: 293px; margin-left:auto; margin-right:auto">';
			//feedItem= feedItem + '<input type="button" onclick="windows.location.href="tel:'+telph+'" value="'+telph+'" class="callbutton"/></div>';
			feedHTML = feedHTML + '<a class="callbutton" style=" width: 294px;height: 51px; "  href="tel:' + telph + '">' + telph + '</a></div>';
			if (e.srcFire == "map")
				Ti.App.fireEvent("updateMapLocations", {
					'bizName' : 'Speedco ' + bizid,
					'bizid' : bizid,
					'sadd' : sadd,
					'city' : city,
					'state' : state,
					'postal' : postal,
					'tel' : telph,
					'latitudeDB' : destLat,
					'longitudeDB' : destLong,
					'tire' : TireService,
					'lube' : LubeService,
					'ins' : AnnualServices

				});

			rows.next();
		};
		db.close();
		//if (e.v == "done" && !runned) {
		try {
			//alert(feeds);
			Ti.API.info("going to fire thusden:" + feedHTML);
			if (e.srcFire == "index") {
				Ti.App.fireEvent('thusden', {
					'feedItem' : feedHTML,
					'lat' : destLat,
					'longitude' : destLong,
					'biz' : 'Speedco ' + bizid,
					'sadd' : sadd,
					'state' : state,
					'city' : city,
					'tel' : telph

				});
			}
			//runned = true;
		} catch(e) {
			alert(e);
		}
	}, timer);
}
var getDestCoords = function(e) {
	//if (injected)
	{
		//alert("fired:getDestCoords");
		//var feedHTML = "";
		var bizid = "";
		var sadd = "";
		var city = "";
		var state = "";
		var postal = "";
		var telph = "";
		var destLat = "";
		var destLong = "";
		var db = Ti.Database.install('speedco.db', 'storeDB');
		var rows = db.execute('SELECT * FROM stores where Store=' + e.st);
		while (rows.isValidRow()) {
			bizid = rows.fieldByName('Store');
			sadd = rows.fieldByName('Address');
			city = rows.fieldByName('City');
			state = rows.fieldByName('ST');
			postal = rows.fieldByName('ZIP');
			telph = rows.fieldByName('Phone');
			destLat = rows.fieldByName('Latitude');
			destLong = rows.fieldByName('Longitude');
			//feedHTML += "";
			//var idx = bizid.substring(8);

			rows.next();
		};
		db.close();
		//directly fire getdirections
		Ti.App.fireEvent('storeDestDetails', {
			"lat" : destLat,
			"longitude" : destLong,
			"State" : state,
			"City" : city,
			"add" : sadd,
			"tel" : telph,
			"bizid" : bizid
		});
	}

}
var nearest = function(e) {

	var array = [];
	var db = Ti.Database.install('speedco.db', 'storeDB');
	var rows = db.execute('SELECT Store,Latitude,Longitude FROM stores');
	while (rows.isValidRow()) {
		var name = 'Speedco' + rows.fieldByName('Store');
		var latitude = rows.fieldByName('Latitude');
		var longitude = rows.fieldByName('Longitude');
		var strings = [name, latitude, longitude];
		array.push(strings);

		rows.next();
	}
	//alert('nearest:'+array[0][0]);
	db.close();
	Ti.App.fireEvent('storeNearestLocations', {
		'arr' : array
	});
}

Ti.App.addEventListener('nearestLocations', nearest);
var getGeo = function(super_e) {
	if (Titanium.Geolocation.locationServicesEnabled == false) {
		alert('Location services disabled');
	} else {

		Titanium.Geolocation.accuracy = Titanium.Geolocation.ACCURACY_BEST;

		Titanium.Geolocation.distanceFilter = 10;

		Titanium.Geolocation.getCurrentPosition(function(e) {
			if (!e.success || e.error) {

				Ti.API.info("Code translation: " + translateErrorCode(e.code));
				alert('GPS is off.Please turn it on.');
				Ti.App.fireEvent('hideLoading', {});
				return;
			}
			//alert("got to getLocation to calc location");
			currentLongitude = e.coords.longitude;
			currentLatitude = e.coords.latitude;
			//	Titanium.App.test = currentLatitude;
			Ti.App.cordlatitude = currentLatitude;
			Ti.App.cordlongitude = currentLongitude;
			if (super_e.from == 'index')
				Ti.App.fireEvent('nearHa', {
					popaLat : currentLatitude,
					popaLong : currentLongitude
				});
		});
	}
}
function translateErrorCode(code) {
	if (code == null) {
		return null;
	}
	switch (code) {
		case Ti.Geolocation.ERROR_LOCATION_UNKNOWN:
			return "Location unknown";
		case Ti.Geolocation.ERROR_DENIED:
			return "Access denied";
		case Ti.Geolocation.ERROR_NETWORK:
			return "Network error";
		case Ti.Geolocation.ERROR_HEADING_FAILURE:
			return "Failure to detect heading";
		case Ti.Geolocation.ERROR_REGION_MONITORING_DENIED:
			return "Region monitoring access denied";
		case Ti.Geolocation.ERROR_REGION_MONITORING_FAILURE:
			return "Region monitoring access failure";
		case Ti.Geolocation.ERROR_REGION_MONITORING_DELAYED:
			return "Region monitoring setup delayed";
	}
}

var storeFavs = function(e) {
	//alert('fav2db fired');
	var db = Ti.Database.install('/HTML/speed.sqlite', 'SPEEDCO_DB');
	//alert('going to write to db');
	db.execute('CREATE TABLE IF NOT EXISTS favorites (fav TEXT)');
	//alert('create table exctd');
	db.execute('DELETE FROM favorites');
	//alert('inserting data..');
	db.execute('INSERT INTO favorites (fav) VALUES (?)', e.data);
	db.close();
}
//adding listener
Ti.App.addEventListener('fav2db', storeFavs);
Ti.App.addEventListener('db2fav', function(e) {
	var db = Ti.Database.install('/HTML/speed.sqlite', 'SPEEDCO_DB');
	//var db = Ti.Database.open('SPEEDCO_DB');
	//alert('reading values');
	var rows = db.execute('SELECT fav FROM favorites');

	while (rows.isValidRow()) {
		//alert('valid rows 1:');
		//+rows.field(1));
		var favText = rows.fieldByName('fav');
		//db_lat = rows.field(1);
		//db_lon = rows.field(2);
		Ti.App.fireEvent('load2local', {
			data : favText
		});
		//Ti.API.info('Person ---&gt; ROWID: ' + rows.fieldByName('rowid') + ', name:' +  + ', phone_number: ' + rows.fieldByName('phone_number') + ', city: ' + rows.field(3));
		rows.next();
	}
	rows.close();
	db.close();
});
Ti.App.addEventListener('getLocation', getGeo);

Ti.App.addEventListener('TiPlat', function(e) {
	try {
		//alert(e.url);
		Titanium.Platform.openURL(e.url);

	} catch(e1) {
		alert(e1);
		Titanium.Platform.openURL('http://maps.google.com/');
	}
});

var globalLat = '';
var globalLong = '';
//bootstrap and check dependencies
//mapview from http://developer.appcelerator.com/question/74221/mobile-map-route-from-google-server#133781

Ti.App.addEventListener('getFeed', createLis);

Ti.App.addEventListener('getFeedPage', createListPage);
Ti.App.addEventListener('getCoords', getDestCoords);
Ti.App.addEventListener('unzip', zipToLatLong);
Ti.App.addEventListener('getReviews', reviews);
Ti.App.addEventListener('getServices', fillServices);
if (Ti.version < 1.8) {
	alert('Sorry - this application template requires Titanium Mobile SDK 1.8 or later');
} else {
	//require and open top level UI component

	var ApplicationWindow = require('ui/ApplicationWindow');
	new ApplicationWindow().open();
}

